#include <bits/stdc++.h>
using namespace std;
#define ll long long

vector<bool> used;
vector<bool> used2;
vector<vector<int> > g;


void bfs(int start, int h) {
    queue<pair<int, int> > q;
    q.push({start, 0});
    used[start] = true;
    used2[start] = true;
    while (!q.empty()) {
        auto [v, s] = q.front();
        q.pop();
        if (s + 1 > h)
            break;
        for (int i = 0; i < g[v].size(); i++) {
            if (!used[g[v][i]]) {
                used[g[v][i]] = true;
                used2[g[v][i]] = true;
                q.push({g[v][i], s + 1});
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    used2.assign(n, false);
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u1, u2;
        cin >> u1 >> u2;
        g[u1 - 1].push_back(u2 - 1);
        g[u2 - 1].push_back(u1 - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        p--;
        used.assign(n, false);
        bfs(p, h);
    }
    int cnt = 0;
    string ans;
    for (int i = 0; i < n; i++) {
        if (used2[i]) {
            cnt++;
            ans += to_string(i + 1) + " ";
        }
    }
    cout << cnt << endl;
    cout << ans << endl;
    return 0;
}
