#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define double long double
mt19937 rnd (52);

struct tch {
    double x, y;
};
vector<tch> v;
vector<bool> used;
vector<tch> order;
int n;
double ans = 1e7;
double INF = 1e7 + 239;

struct line {
    double k, b;
};
double S;

line to_line (tch a, tch b) {
    double x1 = a.x, y1 = a.y;
    double x2 = b.x, y2 = b.y;
    if (x1 == x2) {
        return {INF, x1};
    }
    line l = {(y2-y1)/(x2-x1), -(y2-y1)/(x2-x1)*x1 + y1};
    return l;
}
line perpendicular(line l, tch t) {
    if (l.k == INF) {
        return {0, t.y};
    }
    if (l.k == 0) {
        return {INF, t.x};
    }
    double k = l.k, b = l.b;
    double x1 = t.x, y1 = t.y;
    line a = {-1/k, x1/k+y1};
    return a;
}
tch peresech (line l, line r) {
    if (l.k == INF) {
        return {l.b, l.b*r.k + r.b};
    }
    if (r.k == INF) {
        return {r.b, r.b*l.k + l.b};
    }
    double x = (r.b-l.b)/(l.k - r.k);
    double y = l.k*x + l.b;
    return {x, y};
}
double rass (tch u, tch v) {
    return sqrt((u.x-v.x)*(u.x-v.x)+(u.y-v.y)*(u.y-v.y));
}
line parallel (line l, tch u) {
    if (l.k == INF) {
        return {INF, u.x};
    }
    double k = l.k, b = l.b;
    double x = u.x, y = u.y;
    line a = {k, y-k*x};
    return a;
}

void func (line l, int cnt) {
    if (cnt >= n-1) {
        return;
    }
    tch t = order[cnt+1];
    line p = perpendicular(l, t);
    tch r = peresech(p, l);
    tch m = order[cnt];
    S += rass (m, r) + rass (r, t);
    func (p, cnt+1);
}

void recur (int i) {
    if (i == n) {
        line a = to_line(order[0], order[1]);
        S = 0;
        func (a, 0);
        ans = min (ans, S);
        S = 0;
        if (n>2) {
            line l = to_line(order[1], order[2]);
            a = parallel(l, order[0]);
            func (a, 0);
            ans = min (ans, S);
        }
        return;
    }
    for (int j = 0; j < used.size(); j++) {
        if (!used[j]) {
            used[j] = true;
            order.push_back(v[j]);
            recur(i + 1);
            order.pop_back();
            used[j] = false;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n;
    cout << fixed << setprecision(12);
    if (n == 2) {
        tch a, b;
        cin >> a.x >> a.y;
        cin >> b.x >> b.y;
        cout << rass(a, b);
        return 0;
    }
    used.resize(n);
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].x >> v[i].y;
    }
    recur(0);
    cout << ans;
    return 0;
}
